#include "axle.h"
#include "vehicle.h"
#include "vehicletype.h"

using namespace Msp;

namespace R2C2 {

Axle3D::Axle3D(const Vehicle3D &v, unsigned a):
	VehiclePart3D(v, *v.get_type().get_axle_object(a)),
	bogie(0),
	axle(vehicle.get_vehicle().get_axle(a))
{
	if(axle.type->bogie)
		bogie = &vehicle.get_vehicle().get_bogie(axle.type->bogie->index);
}

void Axle3D::update_matrix()
{
	matrix = vehicle.Object3D::get_matrix();

	if(bogie)
	{
		matrix.translate(bogie->type->position, 0, 0);
		matrix.rotate(bogie->direction, 0, 0, 1);
	}

	matrix.translate(axle.type->local_position, 0, axle.type->wheel_dia/2);
	matrix.rotate(axle.angle, 0, 1, 0);
}

} // namespace R2C2
