#ifndef TERRAINTOOL_H_
#define TERRAINTOOL_H_

#include <msp/gl/mesh.h>
#include <msp/gl/renderable.h>
#include "libr2c2/terrain.h"
#include "tool.h"

class TerrainTool: public Tool, public Msp::GL::Renderable
{
private:
	R2C2::Terrain &terrain;
	Msp::GL::Mesh marker;
	R2C2::Terrain::NodeCoordinates highlight_node;
	unsigned edit_size;
	R2C2::Vector marker_position;
	unsigned marker_orientation;
	bool dragging;
	float drag_start;

public:
	TerrainTool(Designer &, Msp::Input::Keyboard &, Msp::Input::Mouse &, R2C2::Terrain &);
	virtual ~TerrainTool();

private:
	void update_marker();

	virtual void key_press(unsigned);
	virtual void key_release(unsigned);
	virtual void button_press(unsigned);
	virtual void button_release(unsigned);
	virtual void pointer_motion();

public:
	virtual void render(Msp::GL::Renderer &, const Msp::GL::Tag &) const;
};

#endif
