#ifndef LIBR2C2_ZONE_H_
#define LIBR2C2_ZONE_H_

#include <set>
#include <string>
#include <msp/datafile/objectloader.h>
#include "trackchain.h"

namespace R2C2 {

class Layout;
class Track;

class Zone: public TrackChain
{
public:
	class Loader: public Msp::DataFile::ObjectLoader<Zone>
	{
	public:
		Loader(Zone &);
	private:
		virtual void finish();
		void block(unsigned);
	};

private:
	std::string group;
	std::string qualifier;
	unsigned number;

public:
	Zone(Layout &);
	~Zone();

	virtual void set_name(const std::string &);
	void set_name(const std::string &, const std::string &, unsigned);
private:
	void update_name();
public:
	const std::string &get_group() const { return group; }
	const std::string &get_qualifier() const { return qualifier; }
	unsigned get_number() const { return number; }

	void save(std::list<Msp::DataFile::Statement> &) const;
	virtual Msp::DataFile::Statement save_reference() const;
};

} // namespace R2C2

#endif
